//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef RandomAccessStreamParams_h
#define RandomAccessStreamParams_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "nsTHashtable.h"
#include "mozilla/MozPromise.h"
#include "mozilla/OperatorNewExtensions.h"
#include "mozilla/UniquePtr.h"
#include "mozilla/ipc/ByteBuf.h"
#include "mozilla/ipc/FileDescriptor.h"
#include "mozilla/ipc/ProtocolUtilsFwd.h"
#include "mozilla/ipc/Shmem.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileRandomAccessStreamParams|
//
namespace mozilla {
namespace ipc {
class FileRandomAccessStreamParams final
{
private:
    typedef mozilla::ipc::FileDescriptor FileDescriptor;

public:
    MOZ_IMPLICIT FileRandomAccessStreamParams() :
        fileDescriptor_(),
        behaviorFlags_()
    {
    }

    MOZ_IMPLICIT FileRandomAccessStreamParams(
            const FileDescriptor& _fileDescriptor,
            const int32_t& _behaviorFlags) :
        fileDescriptor_(_fileDescriptor),
        behaviorFlags_(_behaviorFlags)
    {
    }

    FileDescriptor&
    fileDescriptor()
    {
        return fileDescriptor_;
    }
    const FileDescriptor&
    fileDescriptor() const
    {
        return fileDescriptor_;
    }

    int32_t&
    behaviorFlags()
    {
        return behaviorFlags_;
    }
    const int32_t&
    behaviorFlags() const
    {
        return behaviorFlags_;
    }

private:
    FileDescriptor fileDescriptor_;
    int32_t behaviorFlags_;
};
} // namespace ipc
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::ipc::FileRandomAccessStreamParams>
{
    typedef mozilla::ipc::FileRandomAccessStreamParams paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union RandomAccessStreamParams|
//
namespace mozilla {
namespace ipc {
class RandomAccessStreamParams final
{
public:
    enum Type {
        T__None,
        TFileRandomAccessStreamParams = 1,
        T__Last = TFileRandomAccessStreamParams
    };

private:
    typedef mozilla::ipc::FileRandomAccessStreamParams FileRandomAccessStreamParams;
    typedef FileRandomAccessStreamParams FileRandomAccessStreamParams__tdef;

    union Value {
        mozilla::AlignedStorage2<FileRandomAccessStreamParams> VFileRandomAccessStreamParams;
    };

    FileRandomAccessStreamParams*
    ptr_FileRandomAccessStreamParams()
    {
        return ((mValue).VFileRandomAccessStreamParams).addr();
    }
    const FileRandomAccessStreamParams*
    constptr_FileRandomAccessStreamParams() const
    {
        return ((mValue).VFileRandomAccessStreamParams).addr();
    }

    void
    MaybeDestroy();

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT RandomAccessStreamParams() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT RandomAccessStreamParams(const FileRandomAccessStreamParams& aOther);

    MOZ_IMPLICIT RandomAccessStreamParams(FileRandomAccessStreamParams&& aOther);

    MOZ_IMPLICIT RandomAccessStreamParams(const RandomAccessStreamParams& aOther);

    MOZ_IMPLICIT RandomAccessStreamParams(RandomAccessStreamParams&& aOther);

    ~RandomAccessStreamParams();

    Type
    type() const
    {
        return mType;
    }

    RandomAccessStreamParams&
    operator=(const FileRandomAccessStreamParams& aRhs);

    RandomAccessStreamParams&
    operator=(FileRandomAccessStreamParams&& aRhs);

    RandomAccessStreamParams&
    operator=(const RandomAccessStreamParams& aRhs);

    RandomAccessStreamParams&
    operator=(RandomAccessStreamParams&& aRhs);

    FileRandomAccessStreamParams&
    get_FileRandomAccessStreamParams()
    {
        AssertSanity(TFileRandomAccessStreamParams);
        return (*(ptr_FileRandomAccessStreamParams()));
    }
    const FileRandomAccessStreamParams&
    get_FileRandomAccessStreamParams() const
    {
        AssertSanity(TFileRandomAccessStreamParams);
        return (*(constptr_FileRandomAccessStreamParams()));
    }
    operator FileRandomAccessStreamParams&()
    {
        return get_FileRandomAccessStreamParams();
    }
    operator const FileRandomAccessStreamParams&() const
    {
        return get_FileRandomAccessStreamParams();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace ipc
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::ipc::RandomAccessStreamParams>
{
    typedef mozilla::ipc::RandomAccessStreamParams paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC

#endif // ifndef RandomAccessStreamParams_h
